c	COMMON AREA STOCHASTIC CODER
c
c	SPECTRUM VARIABLES:
c	d2a	real	memory 1/A(z)
c	d2b	real	memory 1/A(z)
c	d3a	real	memory A(z)
c	d3b	real	memory A(z)
c	d4a	real	memory 1/A(z/gamma)
c	d4b	real	memory 1/A(z/gamma)
c	d5	real	auxiliary array
c	fc	real	LPC filter/weighting filter coefficients
c	fci	real	interpolated weighting filter coefficients
c	fcn	real	new weighting filter coefficients
c	gamma	real	weight factor
c	no	i	filter order  predictor
c
c	PITCH VARIABLES:
c	bb	real	pitch predictor coefficients
c	d1a	real	memory 1/P(z)
c	d1b	real	memory 1/P(z)
c	d6	real	auxiliary array
c	idb	int	dimension of d1a, d1b and d6???
c	tauptr  int	pitch delay pointer
c	minptr	int	minimum delay pointer
c	pbits	int	pitch gain coding bit allocation
c	pindex	int	pitch gain index bb(3)
c	ptype	char	pitch gain (bb(3)) quantizer type
c	prewt   real	pitch prefilter weighting (0.0 = off)
c	pstype  char    pitch search type (hier, full, or intg)
c	pdelay	real	pitch delay coding table
c	plevel1	real	number of full search pitch delays
c	plevel2	real	number of delta search pitch delays
c
c	CODE BOOK VARIABLES:
c	cbgbits	int	code book gain bit allocation
c	cbgtype	char	code book gain quantizer type
c	mxsw	logical	modified excitation switch (on or off)
c	cbindex	int	code book index
c	e0	real	initial error and updated error
c	err	real	error for each code book entry
c	gain	real	gain for each code book entry
c	gindex	int	gain index
c	h	real	impulse response
c	ncsize	int	code book size
c	nseg	int	segment counter
c	x	real	code book
c
c	MISCELLANEOUS:
c	frame	int	frame counter
c
	include 'ccsub.h'
convex	#include "ccsub.h"
c
	common /ccsub/
     +  cbgbits, cbindex, gamma, gindex, idb, ncsize, no,
     +  nseg, tauptr, minptr, pindex, plevel1, plevel2, frame,
     +  bb(maxnp+1), e0(maxlp), err(maxncsize), gain(maxncsize),
     +  d1a(maxpa), d1b(maxpa), d2a(maxno+1), d2b(maxno+1),
     +  d3a(maxno+1), d3b(maxno+1), d4a(maxno+1), d4b(maxno+1),
     +	d5(maxno+1), d6(maxpa), mxsw, prewt, 
     +  fc(maxno+1), fci(maxno+1), fcn(maxno+1),
     +  h(maxlp), pbits(maxnp+2), pdelay(0:maxpd-1), x(maxcode)
c
c	SPECTRUM VARIABLES:
	integer no
	real gamma, fc, fci, fcn
	real d2a, d2b, d3a, d3b, d4a, d4b, d5
c
c	PITCH VARIABLES:
	integer idb, pbits, pindex, plevel1, plevel2, tauptr, minptr
	real bb, d1a, d1b, d6, pdelay, prewt
c
c	CODE BOOK VARIABLES:
	integer cbgbits, cbindex, gindex, ncsize, nseg
	real e0, err, gain, h, x
	logical mxsw
c
c	MISCELLANEOUS:
	integer frame
c
c	Seperate character common block for FORTRAN-77!
c
	common /ccsubchar/ ptype, pstype, cbgtype
c
c	PITCH VARIABLES:
	character*10 ptype
	character*10 pstype
c
c	CODE BOOK VARIABLES:
	character*10 cbgtype
